
; WinNest by kero
; v.2015-02-26
; BSOD via SetWindowLong(hwndPrev,GWL_HWNDPARENT,hwndNext)
; my case: nest.depth (Win7_HomeBasic_sp1_x86 "Window 7 Standard"/"Classic") = 81/74

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

.const
  id    equ 100

.data
 _class  db "window",0
 _d      db "%d",0

.data?
  hinst  HINSTANCE ?
  hwnd1  HWND ?
  hwnd2  HWND ?
  hwnd3  HWND ?
  hwnd4  HWND ?
  hwnd5  HWND ?
  hwnd6  HWND ?

.code

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buf[64]:TCHAR
  local wc:WNDCLASSEX

  .if uMsg==WM_CLOSE
    invoke EndDialog,hWnd,0

  .elseif uMsg==WM_INITDIALOG
    invoke RtlZeroMemory,addr wc,sizeof wc
    mov wc.cbSize,sizeof wc
    mov eax,hinst
    mov wc.hInstance,eax
    mov wc.lpfnWndProc,DefWindowProc
    mov wc.hbrBackground,COLOR_WINDOW
    mov wc.lpszClassName,offset _class
    invoke RegisterClassEx,addr wc    

;1 -> BSOD
  .elseif uMsg==WM_COMMAND && wParam==id+2
    invoke GetDlgItemInt,hWnd,id+1,0,0
    mov esi,eax
    xor edi,edi
    inc edi
    .while edi<=esi
      invoke wsprintf,addr buf,offset _d,edi
      mov ecx,edi
      add ecx,ecx
      add ecx,30
      .if edi==1
        mov ecx,10
      .endif
      invoke CreateWindowEx,
        WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
        offset _class,addr buf,
        WS_VISIBLE or WS_CAPTION or WS_SYSMENU or WS_POPUP,
        ecx,10,200,200,0,0,hinst,0
      .if edi==1
        mov ebx,eax
      .else
        mov edx,ebx
        mov ebx,eax
        mov hwnd1,edx
        invoke SetWindowLong,edx,GWL_HWNDPARENT,ebx
        invoke GetWindow,hwnd1,GW_OWNER
        .if eax==0
          invoke MessageBeep,0
          jmp @f
        .endif
        mov hwnd1,ebx
      .endif
      inc edi
    .endw
@@:
    dec edi
    invoke SetDlgItemInt,hWnd,id+1,edi,1

  .elseif uMsg==WM_COMMAND && wParam==id+3
    invoke DestroyWindow,hwnd1
    xor eax,eax
    mov hwnd1,eax

;2
  .elseif uMsg==WM_COMMAND && wParam==id+5
    invoke GetDlgItemInt,hWnd,id+4,0,0
    mov esi,eax
    xor edi,edi
    inc edi
    .while edi<=esi
      invoke wsprintf,addr buf,offset _d,edi
      mov ecx,edi
      add ecx,ecx
      add ecx,30
      .if edi==1
        mov ecx,10
      .endif
      invoke CreateWindowEx,
        WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
        offset _class,addr buf,
        WS_VISIBLE or WS_CAPTION or WS_SYSMENU or WS_POPUP,
        ecx,10,200,200,0,0,hinst,0
      .if edi==1
        mov hwnd2,eax      
        mov ebx,eax
      .else
        mov edx,ebx
        mov ebx,eax
        invoke SetWindowLong,ebx,GWL_HWNDPARENT,edx
        invoke GetWindow,ebx,GW_OWNER
        .if eax==0
          invoke MessageBeep,0
          invoke DestroyWindow,ebx
          jmp @f
        .endif
      .endif
      inc edi
    .endw
@@:
    dec edi
    invoke SetDlgItemInt,hWnd,id+4,edi,1

  .elseif uMsg==WM_COMMAND && wParam==id+6
    invoke DestroyWindow,hwnd2
    xor eax,eax
    mov hwnd2,eax

;3
  .elseif uMsg==WM_COMMAND && wParam==id+8
    invoke GetDlgItemInt,hWnd,id+7,0,0
    mov esi,eax
    xor ebx,ebx
    xor edi,edi
    inc edi
    .while edi<=esi
      invoke wsprintf,addr buf,offset _d,edi
      mov ecx,edi
      add ecx,ecx
      add ecx,30
      .if edi==1
        mov ecx,10
      .endif
      invoke CreateWindowEx,
        WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
        offset _class,addr buf,
        WS_VISIBLE or WS_CAPTION or WS_SYSMENU or WS_POPUP,
        ecx,10,200,200,ebx,0,hinst,0
      .if edi==1
        mov hwnd3,eax
      .endif
      mov ebx,eax
      .if eax==0
        invoke MessageBeep,0
        invoke DestroyWindow,ebx
        jmp @f
      .endif
      inc edi
    .endw
@@:
    dec edi
    invoke SetDlgItemInt,hWnd,id+7,edi,1

  .elseif uMsg==WM_COMMAND && wParam==id+9
    invoke DestroyWindow,hwnd3
    xor eax,eax
    mov hwnd3,eax

;4
  .elseif uMsg==WM_COMMAND && wParam==id+11
    invoke GetDlgItemInt,hWnd,id+10,0,0
    mov esi,eax
    xor ebx,ebx
    xor edi,edi
    inc edi
    .while edi<=esi
      invoke wsprintf,addr buf,offset _d,edi
      .if edi==1
        xor eax,eax
        mov edx,WS_VISIBLE or WS_CAPTION or WS_SYSMENU
      .else
        mov eax,edi
        mov edx,WS_VISIBLE or WS_CAPTION or WS_SYSMENU or WS_CHILD 
      .endif
      invoke CreateWindowEx,
        WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
        offset _class,addr buf,
        edx,
        0,0,200,200,ebx,eax,hinst,0
      .if edi==1
        mov hwnd4,eax
      .endif
      mov ebx,eax
      .if eax==0
        invoke MessageBeep,0
        invoke DestroyWindow,ebx
        jmp @f
      .endif
      inc edi
    .endw
@@:
    dec edi
    invoke SetDlgItemInt,hWnd,id+10,edi,1

  .elseif uMsg==WM_COMMAND && wParam==id+12
    invoke DestroyWindow,hwnd4
    xor eax,eax
    mov hwnd4,eax

;5
  .elseif uMsg==WM_COMMAND && wParam==id+14
    invoke GetDlgItemInt,hWnd,id+13,0,0
    mov esi,eax
    xor edi,edi
    inc edi
    .while edi<=esi
      invoke wsprintf,addr buf,offset _d,edi
      invoke CreateWindowEx,
        WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
        offset _class,addr buf,
        WS_VISIBLE or WS_CAPTION or WS_SYSMENU,
        0,0,200,200,0,0,hinst,0
      .if edi==1
        mov ebx,eax
      .else
        mov edx,ebx
        mov ebx,eax
        mov hwnd5,edx
        invoke SetParent,edx,ebx
        .if eax==0
          invoke MessageBeep,0
          invoke DestroyWindow,ebx
          jmp @f
        .endif
        mov hwnd5,ebx
      .endif
      inc edi
    .endw
@@:
    dec edi
    invoke SetDlgItemInt,hWnd,id+13,edi,1

  .elseif uMsg==WM_COMMAND && wParam==id+15
    invoke DestroyWindow,hwnd5
    xor eax,eax
    mov hwnd5,eax

;6
  .elseif uMsg==WM_COMMAND && wParam==id+17
    invoke GetDlgItemInt,hWnd,id+16,0,0
    mov esi,eax
    xor edi,edi
    inc edi
    .while edi<=esi
      invoke wsprintf,addr buf,offset _d,edi
      invoke CreateWindowEx,
        WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
        offset _class,addr buf,
        WS_VISIBLE or WS_CAPTION or WS_SYSMENU,
        0,0,200,200,0,0,hinst,0
      .if edi==1
        mov hwnd6,eax      
        mov ebx,eax
      .else
        mov edx,ebx
        mov ebx,eax
        invoke SetParent,ebx,edx
        .if eax==0
          invoke MessageBeep,0
          invoke DestroyWindow,ebx
          jmp @f
        .endif
      .endif
      inc edi
    .endw
@@:
    dec edi
    invoke SetDlgItemInt,hWnd,id+16,edi,1

  .elseif uMsg==WM_COMMAND && wParam==id+18
    invoke DestroyWindow,hwnd6
    xor eax,eax
    mov hwnd6,eax

  .elseif uMsg==WM_LBUTTONDOWN
    invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0

	.else
    xor eax,eax
    jmp @f
  .endif
  xor eax,eax
  inc eax
@@:
  ret
DlgProc endp

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  invoke ExitProcess,eax
  invoke InitCommonControls
end start
